/*
 macos/macinput.c
  input for MacFCEU

  Created: 2008.07.02
  Revised: 2010.04.03

Tuesday, September 29, 2009 10:55 PM EDST
  added screenshift to updatemouse (previous versions didnt work right!).
Tuesday, March 30, 2010 6:01 AM
  doing some clean-up (removed unused code).
  only Button is called now for direct mouse poll.
  UDLR...
*/

#include <string.h>

#include <Events.h>
#include <MacWindows.h>

#include "shell.h"

#include "../FCEU.h"
#include "../input.h"
#include "../general.h"
#include "../common/dface.h"
#include "../common/cheat.h"

#include "macinput.h"
#include "macvideo.h"
#include "config.h"

uint8		NoWaiting = 1, allowUDLR = 0;

static uint32	JSreturn;

int		userinputtype[3] = {SI_GAMEPAD,SI_GAMEPAD,SIFC_NONE};
int		inputtypegi[3];
static int	cspec;

int		gametype;

static uint8	QuizKingData;
static uint8	HyperShotData;
static uint32	MahjongData;
static uint32	FTrainerData;
static uint8	TopRiderData;

static uint8	BWorldData[1+13+1];

#include "keyscan.h"

#define MK(x)				{{BUTTC_KEYBOARD},{0},{MKK(x)},1}
#define MK2(x1,x2)			{{BUTTC_KEYBOARD},{0},{MKK(x1),MKK(x2)},2}
#define MKZ()				{{0},{0},{0},0}

/* ---- keyboard */

static KeyMap	mykeys;

int InitKeyboard()
{
	memset(mykeys,0,sizeof(mykeys));
	return 1;
}

char *GetKeyboard()
{
	GetKeys(mykeys);
	return (char*)mykeys;
}

static int getkeystate(int x)
{
	return _bittst(mykeys,x)!=0;
}

#ifdef env68k
 #define KEY(__a)			_bittst(mykeys,MKK(__a))
 #define getkeystate(x)			_bittst(mykeys,x)
#else
 #define KEY(__a)			getkeystate(MKK(__a))
#endif

static int	DIPS = 0;
static uint8	keyonce[MKK_COUNT];

/*#define KEY_STILLDOWN(__a) keyonce[MKK(__a)]*/

static int _keyonly(int a)
{
	if (getkeystate(a))
	{
		if (!keyonce[a])
			{keyonce[a] = 1; return 1;}
	} else
		keyonce[a] = 0;

	return 0;
}

#define keyonly(__a) _keyonly(MKK(__a))

uint8		cidisabled = 0;

static void dokeycommands(void)
{
	int		shift_down;

	if (inputtypegi[2]==SIFC_FKB)
	{
		if (keyonly(SCROLLLOCK))
			FCEUI_DispMessage("Family Keyboard %sabled.",
				(cidisabled^=1)!=0 ? "en":"dis");
		if (cidisabled)
			return;
	}

	shift_down = KEY(SHIFT);

	if (KEY(COMMAND))
	{
		boolean		direction = keyonly(KP_MINUS)*2+keyonly(KP_PLUS);

		if (direction==2) /* down only */
		{
			if (adjust_soundvolume(-1)>=0)
				FCEUI_DispMessage("Volume: %u",
					soundvolume);
		} else if (direction==1) /* up only */
			if (adjust_soundvolume(1)>=0)
				FCEUI_DispMessage("Volume: %u",
					soundvolume);
		if (keyonly(F4))
			if (shift_down)
				FCEUI_SetRenderDisable(-1,4);
			else
				FCEUI_SetRenderDisable(2,-1);
		InitKeyboard();
		return; /* other menus in menubar... */
	}

	if (keyonly(F4))
		if (shift_down)
			FCEUI_SetRenderDisable(-1,2);
		else
			FCEUI_SetRenderDisable(2,-1);

	NoWaiting&=~1;
	if (KEY(GRAVE)) //&& nocount)
		NoWaiting|= 1;

	if (gametype==GIT_FDS)
	{
		if (keyonly(F6))
			FCEUI_FDSSelect();
		if (keyonly(F8))
			FCEUI_FDSInsert(0);
	}

	if (keyonly(F9))
		FCEUI_SaveSnapshot();

	if (gametype!=GIT_NSF)
	{
		if (keyonly(F5))
			if (shift_down)
				FCEUI_SaveMovie(NULL);
			else
				FCEUI_SaveState(NULL);
		if (keyonly(F7))
			if (shift_down)
				FCEUI_LoadMovie(NULL);
			else
				FCEUI_LoadState(NULL);
	}

	/* F1 toggle moved to shell.c */

	if (gametype==GIT_VSUNI)
	{
		if (keyonly(F8))
			FCEUI_VSUniCoin();
		if (keyonly(F6))
		{
			DIPS^= 1;
			FCEUI_VSUniToggleDIPView();
		}

		if ((DIPS&1)==0)
			goto DIPSless;
		if (keyonly(1))
			FCEUI_VSUniToggleDIP(0);
		if (keyonly(2))
			FCEUI_VSUniToggleDIP(1);
		if (keyonly(3))
			FCEUI_VSUniToggleDIP(2);
		if (keyonly(4))
			FCEUI_VSUniToggleDIP(3);
		if (keyonly(5))
			FCEUI_VSUniToggleDIP(4);
		if (keyonly(6))
			FCEUI_VSUniToggleDIP(5);
		if (keyonly(7))
			FCEUI_VSUniToggleDIP(6);
		if (keyonly(8))
			FCEUI_VSUniToggleDIP(7);
	} else
	{
		static uint8	bbuf[32];
		static int	bbuft;
		static int	barcoder = 0;

		if (keyonly(H))
			FCEUI_NTSCSELHUE();
		if (keyonly(T))
			FCEUI_NTSCSELTINT();
		if (KEY(MINUS))
			FCEUI_NTSCDEC();
		if (KEY(EQUAL))
			FCEUI_NTSCINC();

		if (inputtypegi[2]!=SIFC_BWORLD && cspec!=SIS_DETACH)
			barcoder = 0;
		else if (keyonly(F8))
			if (barcoder^=1)
				{bbuft = 0; FCEUI_DispMessage("Enter Barcode");}
			else
			{
				if (inputtypegi[2]==SIFC_BWORLD)
				{
					strcpy((char*)&BWorldData[1],(const char*)bbuf);
					BWorldData[0] = 1;
				} else
					FCEUI_DetachSet(bbuf);
				FCEUI_DispMessage("Barcode Entered");
			}

	#define SSMi(x)		do{if(keyonly(x)) {if(barcoder) {if(bbuft<13) \
		{bbuf[bbuft++]='0'+x; bbuf[bbuft]=0;} \
		FCEUI_DispMessage("Barcode: %s",bbuf);} else \
		if(shift_down) FCEUI_SelectMovie(x); else FCEUI_SelectState(x);}}while(0)

	DIPSless:
		SSMi(0);
		SSMi(1);
		SSMi(2);
		SSMi(3);
		SSMi(4);
		SSMi(5);
		SSMi(6);
		SSMi(7);
		SSMi(8);
		SSMi(9);
	#undef SSMi
	}
}

/* ---- general */

int DTestButton(ButtConfig *bc)
{
	int		x, t;

	for(x=0; x<bc->NumC; ++x)
		if ((t=bc->ButtType[x])==BUTTC_KEYBOARD)
		{
			if (getkeystate(bc->ButtonNum[x]))
				return 1;
		} else if (t==BUTTC_MOUSE) /*whatever*/
			return Button();

	return 0;
}

/* ---- hypershot */

static ButtConfig	HyperShotButtons[4] =
{
	MK(Q), MK(W), MK(E), MK(R),
};

static void UpdateHyperShot(void)
{ /* unrolled */
	HyperShotData = 0;

	if (DTestButton(&HyperShotButtons[0]))
		HyperShotData|= 1;
	if (DTestButton(&HyperShotButtons[1]))
		HyperShotData|= 2;
	if (DTestButton(&HyperShotButtons[2]))
		HyperShotData|= 4;
	if (DTestButton(&HyperShotButtons[3]))
		HyperShotData|= 8;
}

/* ---- mahjong */

static ButtConfig	MahjongButtons[21] =
{
	MK(Q), MK(W), MK(E), MK(R), MK(T),
	MK(A), MK(S), MK(D), MK(F), MK(G), MK(H), MK(J), MK(K), MK(L),
	MK(Z), MK(X), MK(C), MK(V), MK(B), MK(N), MK(M),
};

static void UpdateMahjong(void)
{
	unsigned	x, b;

	MahjongData = 0;
	for(x=0,b=1; x<21; ++x,b+=b)
		if (DTestButton(&MahjongButtons[x]))
			MahjongData|= b;
}

/* ---- quizking */

ButtConfig	QuizKingButtons[6] =
{
	MK(Q), MK(W), MK(E), MK(R), MK(T), MK(Y),
};

static void UpdateQuizKing(void)
{ /* unrolled */
	QuizKingData = 0;

	if (DTestButton(&QuizKingButtons[0]))
		QuizKingData|= 1;
	if (DTestButton(&QuizKingButtons[1]))
		QuizKingData|= 2;
	if (DTestButton(&QuizKingButtons[2]))
		QuizKingData|= 4;
	if (DTestButton(&QuizKingButtons[3]))
		QuizKingData|= 8;
	if (DTestButton(&QuizKingButtons[4]))
		QuizKingData|= 0x10;
	if (DTestButton(&QuizKingButtons[5]))
		QuizKingData|= 0x20;
}

/* ---- toprider */

ButtConfig	TopRiderButtons[8] =
{
	MK(Q), MK(W), MK(E), MK(R), MK(T), MK(Y), MK(U), MK(I),
};

static void UpdateTopRider(void)
{ /* unrolled */
	TopRiderData = 0;

	if (DTestButton(&TopRiderButtons[0]))
		TopRiderData|= 1;
	if (DTestButton(&TopRiderButtons[1]))
		TopRiderData|= 2;
	if (DTestButton(&TopRiderButtons[2]))
		TopRiderData|= 4;
	if (DTestButton(&TopRiderButtons[3]))
		TopRiderData|= 8;
	if (DTestButton(&TopRiderButtons[4]))
		TopRiderData|= 0x10;
	if (DTestButton(&TopRiderButtons[5]))
		TopRiderData|= 0x20;
	if (DTestButton(&TopRiderButtons[6]))
		TopRiderData|= 0x40;
	if (DTestButton(&TopRiderButtons[7]))
		TopRiderData|= 0x80;
}

/* ---- [f]trainer */

ButtConfig	FTrainerButtons[12] =
{
	MK(O), MK(P), MK(BRACKET_LEFT), MK(BRACKET_RIGHT),
	MK(K), MK(L), MK(SEMICOLON), MK(APOSTROPHE),
	MK(M), MK(COMMA), MK(PERIOD), MK(SLASH),
};

static void UpdateFTrainer(void)
{
	unsigned	x, b;

	FTrainerData = 0;
	for(x=0,b=1; x<12; ++x,b+=b)
		if (DTestButton(&FTrainerButtons[x]))
			FTrainerData|= b;
}

/* ---- emulated keyboard */

static uint8	fkbkeys[0x48];

ButtConfig	fkbmap[0x48] =
{ /* TAB for left ALT? */
	MK(F1), MK(F2), MK(F3), MK(F4), MK(F5), MK(F6), MK(F7), MK(F8),
	MK(1), MK(2), MK(3), MK(4), MK(5), MK(6), MK(7), MK(8), MK(9), MK(0),
		MK(MINUS), MK(EQUAL), MK(BACKSLASH), MK(BACKSPACE), MK(ESCAPE),
	MK(Q), MK(W), MK(E), MK(R), MK(T), MK(Y), MK(U), MK(I), MK(O), MK(P),
		MK(GRAVE), MK(BRACKET_LEFT), MK(RETURN),
	MK(CONTROL), MK(A), MK(S), MK(D), MK(F), MK(G), MK(H), MK(J), MK(K), MK(L),
		MK(SEMICOLON), MK(APOSTROPHE), MK(BRACKET_RIGHT), MK(INSERT),
	MK(SHIFT), MK(Z), MK(X), MK(C), MK(V), MK(B), MK(N), MK(M), MK(COMMA),
		MK(PERIOD), MK(SLASH), MK(OPTION), MK(SHIFT), MK(OPTION), MK(SPACE),
	MK(DELETE), MK(END), MK(PAGEDOWN),
	MK(CURSORUP), MK(CURSORLEFT), MK(CURSORRIGHT), MK(CURSORDOWN),
};

static void UpdateFKB(void)
{
	int		x;

	for(x=0; x<0x48; ++x)
		fkbkeys[x] = DTestButton(&fkbmap[x]);
}

/* ---- mouse */

static uint32	MouseData[3];

boolean updatemouse()
{
	Point		pt;
	CGrafPtr	port;
	const PixMap	**pm;
	const BitMap	*windowmap;

	if ((port=getvisiblewindowport(gamewindow))==NULL)
		return 0;

	GetGlobalMouse(&pt);

	if ((pm=GetPortPixMap(port))==NULL)
		windowmap = GetPortBitMapForCopyBits(port);
	else
		windowmap = (const BitMap*)*pm;

	/* map top/left for window are negative (covers remaining screen space) */
	MouseData[0] = (pt.h+windowmap->bounds.left)>>screenshift;
	MouseData[1] = (pt.v+windowmap->bounds.top)>>screenshift;
	MouseData[2] = Button();

	/* gameinitbounds holds the true size of the window (dont just use 256x240) */
	return (unsigned)MouseData[1]<<screenshift<gameinitbounds.bottom-gameinitbounds.top
		&& (unsigned)MouseData[0]<<screenshift<gameinitbounds.right-gameinitbounds.left;
}

/* ---- gamepad */

gpbutttype	GamePadConfig[4] =
{ /* A, B, Select, Start, Up, Down, Left, Right */
	{ /* Gamepad 1 - was Opt, Ctl, Tab, Ret, Up, Down, Left, Right */
		MK(CONTROL), MK(OPTION), MK(TAB), MK(Q),
		MK(W), MK(S), MK(A), MK(D),
	}, /* FCEUX 2.1 does KP3, KP2, TAB, ENTER, W, Z, A, S */

	{ /* Gamepad 2 */
		MK(SLASH), MK(SHIFT), MK(APOSTROPHE), MK(RETURN),
		MK(CURSORUP), MK(CURSORDOWN), MK(CURSORLEFT), MK(CURSORRIGHT),
	},

	{ /* Gamepad 3 */
		MK(INSERT), MK(PAGEUP), MK(EQUAL), MK(BACKSPACE),
		MK(HOME), MK(END), MK(DELETE), MK(PAGEDOWN),
	},

	{ /* Gamepad 4 */
		MK(KP0), MK(KP_PERIOD), MK(KP_SLASH), MK2(KP_ASTERISK,KP_ENTER),
		MK(KP8), MK(KP5), MK(KP4), MK(KP6),
	},
};

static void UpdateGamepad(void)
{
	static uint8	rapid = 0;
	uint32		JS = 0, wg = 0, wgb = 0;

	//should deny input if movie is playing...
	//if (FCEUMOV_IsPlaying()) return;

	rapid^= 1;

#define TestAddPadButton(x)	do{ \
	if(DTestButton(&GamePadConfig[wg][x])) \
		JS|=(1<<(x&7))<<wgb; \
}while(0)
	do
	{ /* unrolled */
		TestAddPadButton(0);
		TestAddPadButton(1);
		TestAddPadButton(2);
		TestAddPadButton(3);
		TestAddPadButton(4);
		TestAddPadButton(5);
		TestAddPadButton(6);
		TestAddPadButton(7);

		// rapid-fire A and B
		if (rapid)
		{
			TestAddPadButton(8);
			TestAddPadButton(9);
		}
	} while(wgb+=8,++wg<4);
#undef TestAddPadButton
	/* correct conflicting keys (simultaneous up+down) -- process unrolled */
	if (!allowUDLR)
	{
		wgb = ~JS;
		if ((wgb&0x30)==0)
			JS&=~0x30;
		if ((wgb&0xC0)==0)
			JS&=~0xC0;
		if ((wgb&0x3000)==0)
			JS&=~0x3000;
		if ((wgb&0xC000)==0)
			JS&=~0xC000;
		if ((wgb&0x300000)==0)
			JS&=~0x300000;
		if ((wgb&0xC00000)==0)
			JS&=~0xC00000;
		if ((wgb&0x30000000)==0)
			JS&=~0x30000000;
		if ((wgb&0xC0000000U)==0)
			JS&=~0xC0000000U;
	}

	JSreturn = JS;
}

/* ---- powerpad */

ButtConfig	powerpadsc[2][12] =
{
	{
		MK(O), MK(P), MK(BRACKET_LEFT), MK(BRACKET_RIGHT),
		MK(K), MK(L), MK(SEMICOLON), MK(APOSTROPHE),
		MK(M), MK(COMMA), MK(PERIOD), MK(SLASH)
	},
	{
		MK(O), MK(P), MK(BRACKET_LEFT), MK(BRACKET_RIGHT),
		MK(K), MK(L), MK(SEMICOLON), MK(APOSTROPHE),
		MK(M), MK(COMMA), MK(PERIOD), MK(SLASH)
	}
};

static uint32	powerpadbuf[2];

static uint32 UpdatePPadData(int w)
{
	ButtConfig	*ppadtsc = powerpadsc[w];
	uint32		r, b;
	int		x;

	for(x=0,r=0,b=1; x<12; ++x,b+=b)
		if (DTestButton(&ppadtsc[x]))
			r|= b;

	return r;
}

/* ---- input GI */

void FCEUD_UpdateInput()
{ /* Apple's input always active (interrupt time) */
	int		x, t = 0;

	if (suspended) //background fix; 2010.04.03
		return;

	GetKeys(mykeys);

	dokeycommands();

	for(x=0; x<2; ++x)
		switch(inputtypegi[x])
		{
		case SI_GAMEPAD:
			t|= 1;
			break;
		case SI_ARKANOID:
			t|= 2;
			break;
		case SI_ZAPPER:
			t|= 2;
			break;
		case SI_POWERPADA:
		case SI_POWERPADB:
			powerpadbuf[x] = UpdatePPadData(x);
		}

	switch(inputtypegi[2])
	{
	case SIFC_ARKANOID:
		t|= 2;
		break;
	case SIFC_SHADOW:
		t|= 2;
		break;
	case SIFC_FKB:
		if (cidisabled)
			UpdateFKB();
		break;
	case SIFC_HYPERSHOT:
		UpdateHyperShot();
		break;
	case SIFC_MAHJONG:
		UpdateMahjong();
		break;
	case SIFC_QUIZKING:
		UpdateQuizKing();
		break;
	case SIFC_FTRAINERB:
	case SIFC_FTRAINERA:
		UpdateFTrainer();
		break;
	case SIFC_TOPRIDER:
		UpdateTopRider();
		break;
	case SIFC_OEKAKIDS:
		t|= 2;
	}

	if (t&1)
		UpdateGamepad();
	if (t&2)
		MouseData[2]|= Button();
}

static void initializeinput(void)
{
	void		*dataptr;
	int		x;

	for(x=0; x<2; ++x)
	{
		dataptr = 0;
		switch(inputtypegi[x])
		{
		case SI_POWERPADA:
		case SI_POWERPADB:
			dataptr = x+powerpadbuf;
			break;
		case SI_GAMEPAD:
			dataptr = &JSreturn;
			break;
		case SI_ZAPPER:
			/*attrib = fullscreen;*/
		case SI_ARKANOID:
			dataptr = MouseData;
		}
		FCEUI_SetInput(x,inputtypegi[x],dataptr,0);
	}

	dataptr = 0;
	switch(inputtypegi[2])
	{
	case SIFC_SHADOW:
	case SIFC_OEKAKIDS:
		dataptr = MouseData;
		break;
	case SIFC_FKB:
		dataptr = fkbkeys;
		break;
	case SIFC_HYPERSHOT:
		dataptr = &HyperShotData;
		break;
	case SIFC_MAHJONG:
		dataptr = &MahjongData;
		break;
	case SIFC_QUIZKING:
		dataptr = &QuizKingData;
		break;
	case SIFC_TOPRIDER:
		dataptr = &TopRiderData;
		break;
	case SIFC_BWORLD:
		dataptr = BWorldData;
		break;
	case SIFC_FTRAINERA:
	case SIFC_FTRAINERB:
		dataptr = &FTrainerData;
	}

	FCEUI_SetInputFC(inputtypegi[2],dataptr,0);
	FCEUI_DisableFourScore(eoptions&EO_NOFOURSCORE);
}

void parseinputgi(FCEUGI *gi)
{
	inputtypegi[0] = userinputtype[0];
	inputtypegi[1] = userinputtype[1];
	inputtypegi[2] = userinputtype[2];

	if (gi!=NULL)
	{
		if (gi->input[0]>=0)
			inputtypegi[0] = gi->input[0];
		if (gi->input[1]>=0)
			inputtypegi[1] = gi->input[1];
		if (gi->inputfc>=0)
			inputtypegi[2] = gi->inputfc;
		cspec = gi->cspecial;
		gametype = gi->type;

		initializeinput();
	} else
		cspec = gametype = 0;
}

CFGSTRUCT InputConfig[] =
{
	ACA(userinputtype),
	AC(powerpadsc),
	AC(QuizKingButtons),
	AC(FTrainerButtons),
	AC(HyperShotButtons),
	AC(MahjongButtons),
	AC(GamePadConfig),
	AC(fkbmap),
	AC(allowUDLR),
	ENDCFGSTRUCT
};

void config_inputdialog()
{ //hey! the select and start buttons are in the wrong visual order...
	if (input_dialog(GamePadConfig,0)>0)
		/*input_dialog(GamePadConfig+2,1)*/; //just damn ugly
}
