/*
 macos/shellmenus.h

  Created: 2008.08.04
  Revised: 2010.04.02
*/

#ifndef __SHELLMENUS_H
 #define __SHELLMENUS_H

 #define menuid_apple			80
 #define menuid_file			81
 #define menuid_edit			84
 #define menuid_emulator		82
 #define menuid_special			83
 #define submenuid_sound		85
 #define submenuid_volume		86
 #define submenuid_video		87
 #define submenuid_channels		88
 #define submenuid_speed		89
 #define submenuid_background		90

 /* 'cause Apple made the Rez template mark char a `char`, and not a literal */
 #define submenuchr_sound		"\125"
 #define submenuchr_volume		"\126"
 #define submenuchr_video		"\127"
 #define submenuchr_channels		"\130"
 #define submenuchr_speed		"\131"
 #define submenuchr_background		"\132"

 #if !defined(rez) && !defined(derez)
  #ifndef __SHELL_H
   #include "shell.h"
  #endif

/* ---- menu prototypes */

void reenablemenus(boolean enable);

void updatemenus(void);
boolean domenu(uint16 itemcode);
void redomenusgi(struct FCEUGI *gi);

void reenablemenus(boolean enable); /* for fake modal routines */

boolean setmenuitemstr(uint16 itemcode, const uint8 *text);
boolean enablemenuitem(uint16 itemcode, boolean enabled);
boolean enablemenu(uint16 itemcode, uint8 count, boolean enabled);
boolean checkmenuitem(uint16 itemcode, uint16 check); //bit 15: use diamond
boolean checkmenu(uint16 firstitemcode, uint8 index, boolean invert);
void drawmenubar(void);

void ShowMenuBar(void);
void HideMenuBar(void);
boolean ismenubarvisible(void);

#ifdef __MENUS__
EXTERN_API(Boolean) IsMenuItemEnabled(MenuRef menu, MenuItemIndex item);
EXTERN_API(RgnHandle) GetDragGrayBounds(void); /* added; 2009.10.09 05:25 EDT */
#endif

 #endif /*!defined(rez) && !defined(derez)*/
#endif /*!defined(__SHELLMENUS_H)*/
