#if 0 /*
#  This is a C/MPW script hybrid!
# Just execute this on the command line, as is - Really!

Unset 2; (Evaluate "{0}"=~/()2:/) dev:null

SC "{0}" -enum int -p -dump "{2}:Headers68K"
MrC "{0}" -enum int -p -dump "{2}:HeadersPPC"
Delete "{0}.o" -i

Echo "# `Date -t` ----- Done."; Echo {1} -n; Exit 0
#*/
#endif
/*
 *  MacHeaders.c - source to MacOS Precompiled Headers
 *		(based on "Mac #includes.c")
 *
 *  Revised: 2009.01.06 05:51 GMT
 *
 *	Interfaces are grouped by functionality, i.e. all Apple Event
 *	related headers are in their own section. Each header can be
 *	included or excluded from the precompiled header as follows:
 *
 *  To add a header, change its "#if 0" to "#if 1".
 *
 *  To remove a header, change its "#if 1" to "#if 0".
 *
 *  There are some conflicts and order dependencies among the various
 *  headers:
 *
 *		<asm.h> and <Traps.h>, if both are included, must appear
 *		in that order.  If <Traps.h> is included, traps used in
 *		inline assembly must appear without leading underscores.
 *
 *  If the "Check Pointer Types" option is disabled during the
 *  precompilation process, trap definitions will be stored in
 *  such a way that when a trap is called (in a source file that
 *  #includes the precompiled header), pointer arguments to the
 *  trap will not be matched against the types of corresponding
 *  formal parameters.
 *
 *  This is accomplished by storing "simplified" prototypes for
 *  traps, in which any argument of pointer type is stored as
 *  "void *".  The result closely resembles the treatment of traps
 *  in pre-5.0 versions of THINK C.
 *
 *  (Note that this file is written in such a way that it is immune
 *  to the actual compiler setting of "Check Pointer Types".  Use
 *  the "SIMPLIFY_PROTOTYPES" macro, below, to control whether full
 *  prototypes are retained.)
 *
 *	Note that none of the foregoing applies to Symantec C++, nor to 
 *	Symantec C/C++ for MPW.  If a compiler other than THINK C
 *  precompiles this file, asm.h and LoMem.h are #if'd out.  If an
 *  MPW-hosted compiler precompiles this file, pascal.h is #if'd out.
 *
 *	LoMem.h is antiquated and should not be used.
 *  Use <LowMem.h> instead.
 *
 *	This file uses the Universal 3.4.2 interfaces found on Apple's
 *  developers website.
 */

#ifndef _H_MacHeaders
#define _H_MacHeaders

#ifndef __SC__

// set this to 0 (zero) to retain full prototypes
// set this to 1 (one) for "simplified" prototypes
#define SIMPLIFY_PROTOTYPES		0


// prototype checking level
#if SIMPLIFY_PROTOTYPES
	#if !__option(check_ptrs)
		#undef SIMPLIFY_PROTOTYPES
	#endif
	#pragma options(!check_ptrs)
#else
	#if __option(check_ptrs)
		#undef SIMPLIFY_PROTOTYPES
	#endif
	#pragma options(check_ptrs)
#endif	// SIMPLIFY_PROTOTYPES

#endif	// __SC__

/*
 * setting OLDROUTINENAMES to 1 enables "old" names for Macintosh system calls
 * (eg. DisposPtr rather than DisposePtr).  Future versions of MacOS will not
 * support the old names, and Apple strongly recommends that your source code
 * be updated to use the new ones, so for future compatibility set this to 0.
 * For further information see <ConditionalMacros.h>.
 */
#ifndef OLDROUTINENAMES
#define OLDROUTINENAMES 0
#endif

// Core Toolbox Interfaces
	#if 1
		#include <ConditionalMacros.h>
	#endif

	#if 1
		#include <Controls.h>
	#endif

	#if 1
		#include <Dialogs.h>
	#endif

	#if 1
		#include <Events.h>
	#endif

	#if 1
		#include <Files.h>
	#endif

	#if 1
		#include <Fonts.h>
	#endif

	#if 1
		#include <Lists.h>
	#endif

	#if 1
		#include <Memory.h>
	#endif

	#if 1
		#include <Menus.h>
	#endif

	#if 1
		#include <Quickdraw.h>
	#endif

	#if 1
		#include <QuickdrawText.h>
	#endif

	#if 1
		#include <Resources.h>
	#endif

	#if 1
		#include <Types.h>
	#endif

	#if 1
		#include <Windows.h>
	#endif

// ADB Interfaces
	#if 0
		#include <DeskBus.h>
	#endif

// AOCE Interfaces
	#if 0
		#include <DigitalSignature.h>
	#endif

	#if 0
		#include <OCE.h>
	#endif

	#if 0
		#include <OCEAuthDir.h>
	#endif

	#if 0
		#include <OCEErrors.h>
	#endif

	#if 0
		#include <OCEMail.h>
	#endif

	#if 0
		#include <OCEMessaging.h>
	#endif

	#if 0
		#include <OCEStandardDirectory.h>
	#endif

	#if 0
		#include <OCEStandardMail.h>
	#endif

	#if 0
		#include <OCETemplates.h>
	#endif

// AppleEvent Interfaces
	#if 1
		#include <AEObjects.h>
	#endif
	
	#if 1
		#include <AEPackObject.h>
	#endif

	#if 1
		#include <AERegistry.h>
	#endif

	#if 0
		#include <AEUserTermTypes.h>
	#endif

	#if 1
		#include <Appearance.h>
	#endif

	#if 1
		#include <AppleEvents.h>
	#endif

	#if 0
		#include <AppleScript.h>
	#endif

	#if 0
		#include <ASDebugging.h>
	#endif

	#if 0
		#include <ASRegistry.h>
	#endif

// AppleGuide and Balloon Help
	#if 0
		#include <AppleGuide.h>
	#endif

	#if 0
		#include <Balloons.h>
	#endif

// Code Fragment Manager
	#if 0
		#include <CodeFragments.h>
	#endif

// ColorSync 2.0 Interfaces
	#if 0
		#include <CMAcceleration.h>
	#endif

	#if 0
		#include <CMApplication.h>
	#endif

	#if 0
		#include <CMComponent.h>
	#endif

	#if 0
		#include <CMConversions.h>
	#endif

	#if 0
		#include <CMICCProfile.h>
	#endif

	#if 0
		#include <CMMComponent.h>
	#endif

	#if 0
		#include <CMPRComponent.h>
	#endif

// Color Picker
	#if 0
		#include <ColorPicker.h>
	#endif
	
	#if 0
		#include <ColorPickerComponents.h>
	#endif

// Communications Toolbox
	#if 0
		#include <CommResources.h>
	#endif

	#if 0
		#include <Connections.h>
	#endif

	#if 0
		#include <ConnectionTools.h>
	#endif

	#if 0
		#include <CRMSerialDevices.h>
	#endif

	#if 0
		#include <CTBUtilities.h>
	#endif

	#if 0
		#include <FileTransfers.h>
	#endif

	#if 0
		#include <FileTransferTools.h>
	#endif

	#if 0
		#include <Terminals.h>
	#endif

	#if 0
		#include <TerminalTools.h>
	#endif

// Component Manager
	#if 0
		#include <Components.h>
	#endif

// Control Strip
	#if 0
		#include <ControlStrip.h>
	#endif

// Cursor Devices
	#if 0
		#include <CursorDevices.h>
	#endif

// Database Access Manager
	#if 0
		#include <DatabaseAccess.h>
	#endif

// Device Manager
	#if 1
		#include <Devices.h>
	#endif

// Dictionary Manager
	#if 0
		#include <Dictionary.h>
	#endif

// Disk Initialization Package
	#if 1
		#include <DiskInit.h>
	#endif

// Disk Driver
	#if 0
		#include <Disks.h>
	#endif

// Display Manager
	#if 0
		#include <Displays.h>
	#endif

// Drag Manager
	#if 0
		#include <Drag.h>
	#endif

// Edition Manager
	#if 0
		#include <Editions.h>
	#endif

// Errors
	#if 1
		#include <Errors.h>
	#endif

// Event Manager (cf. Core Toolbox Interfaces)
	#if 0
		#include <EPPC.h>
	#endif

// File Management (cf. Core Toolbox Interfaces)
	#if 0
		#include <Aliases.h>
	#endif

	#if 0
		#include <FileTypesAndCreators.h>
	#endif

	#if 0
		#include <Folders.h>
	#endif

	#if 0
		#include <FSM.h>
	#endif

// Finder
	#if 0
		#include <Finder.h>
	#endif

// FixMath
	#if 0
		#include <FixMath.h>
	#endif

// Floating Point Interfaces
	#if 0
		#include <fp.h>
	#endif

// Gestalt
	#if 1
		#include <Gestalt.h>
	#endif

// HyperXCmd
	#if 0
		#include <HyperXCmd.h>
	#endif

// Icon Utilities
	#if 0
		#include <Icons.h>
	#endif

// MIDI Manager
	#if 0
		#include <MIDI.h>
	#endif

// Mixed Mode Manager
	#if 0
		#include <MixedMode.h>
	#endif

// Networking Interfaces
	#if 0
		#include <ADSP.h>
	#endif

	#if 0
		#include <ADSPSecure.h>
	#endif

	#if 0
		#include <AppleTalk.h>
	#endif

	#if 0
		#include <ENET.h>
	#endif

// Notification Manager
	#if 1
		#include <Notification.h>
	#endif

// NuBus Card ROM Definitions
	#if 0
		#include <ROMDefs.h>
	#endif

// Open Scripting Architecture
	#if 0
		#include <OSA.h>
	#endif

	#if 0
		#include <OSAComp.h>
	#endif

	#if 0
		#include <OSAGeneric.h>
	#endif

// OS Utililities
	#if 1
		#include <OSUtils.h>
	#endif

// Package Manager
	#if 1
		#include <Packages.h>
	#endif

// Palette Manager
	#if 0
		#include <Palettes.h>
	#endif

// Picture Utilities
	#if 0
		#include <PictUtils.h>
	#endif

// Power Manager
	#if 0
		#include <Power.h>
	#endif

// PPC Toolbox
	#if 0
		#include <PPCToolBox.h>
	#endif

// Print Manager
	#if 0
		#include <Printing.h>
	#endif

// Process Manager
	#if 0
		#include <Processes.h>
	#endif

// Processor Exceptions
	#if 0
		#include <MachineExceptions.h>
	#endif

// QuickDraw Interfaces (cf. Core Toolbox Interfaces)
	#if 0
		#include <QDOffscreen.h>
	#endif

// QuickDraw GX Interfaces
	#if 0
		#include <Collections.h>
	#endif

	#if 0
		#include <GXEnvironment.h>
	#endif

	#if 0
		#include <GXErrors.h>
	#endif

	#if 0
		#include <GXFonts.h>
	#endif

	#if 0
		#include <GXGraphics.h>
	#endif

	#if 0
		#include <GXLayout.h>
	#endif

	#if 0
		#include <GXMath.h>
	#endif

	#if 0
		#include <GXMessages.h>
	#endif

	#if 0
		#include <GXPrinterDrivers.h>
	#endif

	#if 0
		#include <GXPrinting.h>
	#endif

	#if 0
		#include <GXTypes.h>
	#endif

	#if 0
		#include <ScalarTypes.h>
	#endif

	#if 0
		#include <SFNTTypes.h>
	#endif

// QuickTime Interfaces
	#if 0
		#include <ImageCodec.h>
	#endif

	#if 0
		#include <ImageCompression.h>
	#endif

	#if 0
		#include <MediaHandlers.h>
	#endif

	#if 0
		#include <Movies.h>
	#endif

	#if 0
		#include <MoviesFormat.h>
	#endif

	#if 0
		#include <QuickTimeComponents.h>
	#endif
	
// Scrap Manager
	#if 1
		#include <Scrap.h>
	#endif

// Script Manager Interfaces
	#if 0
		#include <IntlResources.h>
	#endif

	#if 1
		#include <Script.h>
	#endif

	#if 0
		#include <WorldScript.h>
	#endif

// SCSI Manager
	#if 0
		#include <SCSI.h>
	#endif

// Segment Loader
	#if 1
		#include <SegLoad.h>
	#endif

// Serial Port Interfaces
	#if 0
		#include <Serial.h>
	#endif

// Slot Manager
	#if 0
		#include <Slots.h>
	#endif

// Sound Interfaces
	#if 0
		#include <AIFF.h>
	#endif

	#if 0
		#include <Sound.h>
	#endif

	#if 0
		#include <SoundComponents.h>
	#endif
	
	#if 0
		#include <SoundInput.h>
	#endif

// Speech Manager
	#if 0
		#include <Speech.h>
	#endif

// Standard File Interfaces
	#if 1
		#include <StandardFile.h>
	#endif

// Start/Shutdown Manager
	#if 0
		#include <Start.h>
	#endif

	#if 0
		#include <ShutDown.h>
	#endif

// Text Handling
	#if 1
		#include <Strings.h>
	#endif

	#if 1
		#include <TextEdit.h>
	#endif

	#if 1
		#include <TextServices.h>
	#endif

	#if 1
		#include <TextUtils.h>
	#endif
	
	#if 0
		#include <TSMTE.h>
	#endif

// Thread Manager
	#if 0
		#include <Threads.h>
	#endif

// Time Manager
	#if 1
		#include <Timer.h>
	#endif

// ToolUtils
	#if 1
		#include <ToolUtils.h>
	#endif

// Translation Manager
	#if 0
		#include <Translation.h>
	#endif
	
	#if 0
		#include <TranslationExtensions.h>
	#endif

// Vertical Retrace (VBL) Interfaces
	#if 0
		#include <Retrace.h>
	#endif

// Video Driver
	#if 0
		#include <Video.h>
	#endif

/* Symantec Interfaces */

// pascal.h
	#if 0
		#include <pascal.h>
	#endif

// asm.h
#ifdef THINK_C
	#if 1
		#include <asm.h>
	#endif
#else
	#if 0
		#include <asm.h>
	#endif
#endif

// LoMem
	#if 1
		#if defined(__CONDITIONALMACROS__) && !defined(__LOWMEM__)
			#include <LowMem.h>
		#elif !defined(__cplusplus) && !defined(__LOWMEM__)
			#include <LoMem.h>
		#endif
	#endif

// THINK
	#if 0
		#include <THINK.h>
	#endif

// Traps - included here after asm.h (see notes above)
	#if 0
		#include <Traps.h>
	#endif


#ifndef __SC__

// restore "Check Pointer Types" to previous setting
#if SIMPLIFY_PROTOTYPES
	#pragma options(check_ptrs)
#elif defined(SIMPLIFY_PROTOTYPES)
	#pragma options(!check_ptrs)
#endif
#undef SIMPLIFY_PROTOTYPES

#endif	// __SC__

#endif	// _H_MacHeaders
